Subject: Re: bug#67661: 30.0.50; *Completions* has started popping up for icomplete-in-buffer

From: Sean Whitton <[email-masked]>
Date: Sat, 09 Dec 2023 19:04:25 +0000

Hello,

On Sat 09 Dec 2023 at 07:19pm +02, Juri Linkov wrote:

>>> I was referring to the specific case that Sean's recipe illustrated.
>>> This case exhibits a change in behavior that you clearly described, and
>>> that change is supposedly for the worse.  IIUC what bothers Sean is that
>>> both interfaces appear together, but the thing is that that seems to be
>>> inherent to how `icomplete-in-buffer` currently works.
>>
>> No, what bothers me is the regression as described by Eli.
>
> By definition a regression is a bug where a feature that has worked before
> stops working.  As you noted, icomplete-in-buffer didn't work for years,
> until I fixed it for Emacs 29 (as least brought it to a usable state).
> The test case that you described shows its effect only by accident,
> until Eshel improved the related behavior of completion-in-region-mode,
> so that now icomplete-in-buffer works consistently when it enables
> both at the same time: in-buffer completions and in *Completions*.
>
> So instead of trying to restore an arbitrary behavior at the moment
> just after icomplete-in-buffer became usable, it would be much more
> useful to invest energy to deciding how better to finish this feature.

Okay, well, if we think about it in terms of finishing the feature, then
as the person who worked on it previously, could you share how you think
it ought to work?

ISTM that a single tab in Eshell starting completion, and a single tab
not popping up a *Completions* buffer, are pretty clearly what we would
want it to do, but maybe I just got used to it :)

-- 
Sean Whitton